#include <cstdio>
#include <cstdlib>
#include <ltdl.h>
using namespace std;

int
main(int argc, char *argv[])
{
  LTDL_SET_PRELOADED_SYMBOLS();
  if (lt_dlinit() != 0) {
    fprintf(stderr, "%s\n", lt_dlerror());
    exit(EXIT_FAILURE);
  }

  printf("number of arguments: %d\n", argc);
  for (int i = 0; i < argc; ++i) {
    printf("\t[%2d] %s\n", i, argv[i]);
  }

  printf("ltdl initialised\n"
         "trying to open module \"%s\"\n", argv[1]);

  lt_dlhandle h;

  h = lt_dlopen(argv[1]);
  if (!h) {
    fprintf(stderr, "%s\n", lt_dlerror());
    exit(EXIT_FAILURE);
  }

  void (*run)(void);
  run = ( void (*)(void) ) lt_dlsym(h, "run");
  if (NULL == run) {
    fprintf(stderr, "%s\n", lt_dlerror());
    return false;
  }
  run();

  exit(EXIT_SUCCESS);
}
